diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 1676e3720..a0a111915 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -98,7 +98,7 @@ public class PacketHandlerServer extends PacketHandler
         WorldServer world = mcServer.getDimensionWorld(playerEntity.dimension);
         if (playerEntity.getGamemode() == Gamemode.creative && world.isBlockLoaded(packet.xPosition, packet.yPosition, packet.zPosition))
         {
-            TileEntity tileentity = world.getBlockEntity(packet.xPosition, packet.yPosition, packet.zPosition);
+            TileEntity tileentity = world.getTileEntity(packet.xPosition, packet.yPosition, packet.zPosition);
             if (tileentity instanceof TileEntityMobSpawner)
             {
                 TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
@@ -111,6 +111,13 @@ public class PacketHandlerServer extends PacketHandler
         }
     }
 
+    @Override
+    public void handlePlayerConfig(PacketPlayerConfig packetPlayerConfig) {
+        playerEntity.playerConfig.config = packetPlayerConfig.config;
+        packetPlayerConfig.entityId = playerEntity.id;
+        mcServer.playerList.sendPacketToAllPlayersInDimension(packetPlayerConfig, playerEntity.dimension);
+    }
+
     @Override
     public void handleFlying(PacketMovePlayer packet)
     {
@@ -591,7 +598,7 @@ public class PacketHandlerServer extends PacketHandler
     @Override
     public void handleUseEntity(PacketInteract interactPacket)
     {
-        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive() || playerEntity.getHeldObject() != null /*TODO consider adding entity interactions while holding object*/) return;
+        if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         Entity targetEntity = worldserver.getEntityFromId(interactPacket.targetEntityID);
         if (targetEntity != null && playerEntity.distanceToSqr(targetEntity) < 36D)
@@ -701,10 +708,10 @@ public class PacketHandlerServer extends PacketHandler
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         if (worldserver.isBlockLoaded(signUpdatePacket.xPosition, signUpdatePacket.yPosition, signUpdatePacket.zPosition))
         {
-            TileEntity blockEntity = worldserver.getBlockEntity(signUpdatePacket.xPosition, signUpdatePacket.yPosition, signUpdatePacket.zPosition);
-            if (blockEntity instanceof TileEntitySign)
+            TileEntity tileEntity = worldserver.getTileEntity(signUpdatePacket.xPosition, signUpdatePacket.yPosition, signUpdatePacket.zPosition);
+            if (tileEntity instanceof TileEntitySign)
             {
-                TileEntitySign sign = (TileEntitySign) blockEntity;
+                TileEntitySign sign = (TileEntitySign) tileEntity;
                 if (!sign.isEditableBy(playerEntity))
                 {
                     LOGGER.warn("Player {} just tried to change non-editable sign", playerEntity.username);
@@ -736,18 +743,18 @@ public class PacketHandlerServer extends PacketHandler
                 }
             }
 
-            if (blockEntity instanceof TileEntitySign)
+            if (tileEntity instanceof TileEntitySign)
             {
                 int x = signUpdatePacket.xPosition;
                 int y = signUpdatePacket.yPosition;
                 int z = signUpdatePacket.zPosition;
-                TileEntitySign tileEntity = (TileEntitySign) blockEntity;
-                System.arraycopy(signUpdatePacket.signLines, 0, tileEntity.signText, 0, 4);
+                TileEntitySign sign = (TileEntitySign) tileEntity;
+                System.arraycopy(signUpdatePacket.signLines, 0, sign.signText, 0, 4);
 
-                tileEntity.setColor(TextFormatting.FORMATTINGS[signUpdatePacket.color]);
-                tileEntity.setPicture(EnumSignPicture.values()[signUpdatePacket.picture]);
+                sign.setColor(TextFormatting.FORMATTINGS[signUpdatePacket.color]);
+                sign.setPicture(EnumSignPicture.values()[signUpdatePacket.picture]);
 
-                tileEntity.setChanged();
+                sign.setChanged();
                 worldserver.markBlockNeedsUpdate(x, y, z);
             }
         }
diff --git a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
index d57432252..700807044 100644
--- a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -301,7 +301,7 @@ public class PlayerManager
                 int z = chunkZ * Chunk.CHUNK_SIZE_Z + minZ;
                 sendPacketToPlayersInInstance(new PacketBlockUpdate(x, y, z, world));
                 if (Blocks.isEntityTile[world.getBlockId(x, y, z)]) {
-                    updateTileEntity(world.getBlockEntity(x, y, z));
+                    updateTileEntity(world.getTileEntity(x, y, z));
                 }
             }
             else if(numBlocksToUpdate >= 10)
@@ -340,7 +340,7 @@ public class PlayerManager
                     int z = chunkZ * 16 + (blocksToUpdate[k] >> 4 & 0x0F);
                     if(Blocks.isEntityTile[world.getBlockId(x, y, z)])
                     {
-                        updateTileEntity(world.getBlockEntity(x, y, z));
+                        updateTileEntity(world.getTileEntity(x, y, z));
                     }
                 }
 
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index f4fca8d05..b2230135f 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -117,7 +117,7 @@ public class ServerPlayerController
     		}
     	}
         Block<?> block = Blocks.getBlock(id);
-        TileEntity tileEntity = thisWorld.getBlockEntity(x, y, z);
+        TileEntity tileEntity = thisWorld.getTileEntity(x, y, z);
         thisWorld.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, x, y, z, id);
         boolean flag = removeBlock(x, y, z);
         if(flag) {
@@ -167,7 +167,7 @@ public class ServerPlayerController
         int blockId = world.getBlockId(blockX, blockY, blockZ);
         if (player.getHeldObject() == null) {
             if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
-                TileEntity tileEntity = world.getBlockEntity(blockX, blockY, blockZ);
+                TileEntity tileEntity = world.getTileEntity(blockX, blockY, blockZ);
                 if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
                     player.setHeldObject(tileEntity.pickup(world, player));
                     return true;
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldManager.java b/game/server/src/main/java/net/minecraft/server/world/WorldManager.java
index 1690a0067..545cf873b 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldManager.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldManager.java
@@ -113,7 +113,7 @@ public class WorldManager
     @Override
 	public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity)
     {
-        mcServer.playerList.sendBlockEntityToPlayer(x, y, z, worldServer.dimension.id, tileEntity);
+        mcServer.playerList.sendTileEntityToPlayer(x, y, z, worldServer.dimension.id, tileEntity);
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index b1f1b84ca..41383842a 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -219,7 +219,7 @@ public class WorldServer extends World
         super.tick();
 
         if (System.currentTimeMillis() - lastWeatherSend > 1000) {
-            mcServer.playerList.sendPacketToAllPlayers(new PacketWeatherStatus(dimension.id, getCurrentWeather() != null ? getCurrentWeather().weatherId : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().weatherId : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
+            mcServer.playerList.sendPacketToAllPlayers(new PacketWeatherStatus(dimension.id, getCurrentWeather() != null ? getCurrentWeather().getId() : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().getId() : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
             lastWeatherSend = System.currentTimeMillis();
         }
     }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 6f2b8a8c5..193e63c42 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1,5 +1,8 @@
 package net.minecraft.datagen;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStatue;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
 import net.minecraft.datagen.recipeBuilders.RecipeBuilderShaped;
 import net.minecraft.core.block.Blocks;
@@ -59,6 +62,8 @@ class WorkbenchGenerator {
 
         generateUndyeingRecipes();
 
+        generateStatueRecipes();
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
                 .setShape(
                     "CCW",
@@ -1326,4 +1331,23 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
     }
+
+    private static void generateStatueRecipes() {
+        final String[] statueNames = new String[] { "stone", "basalt", "limestone", "granite", "marble" };
+        final Item[] statueItems = new Item[ ] { Items.STATUE_STONE, Items.STATUE_BASALT, Items.STATUE_LIMESTONE, Items.STATUE_GRANITE, Items.STATUE_MARBLE };
+        final Block<?>[] statueBodyBlocks = new Block[] { Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.MARBLE };
+        final Block<?>[] statueBaseBlocks = new Block[] { Blocks.SLAB_STONE_POLISHED, Blocks.SLAB_BASALT_POLISHED, Blocks.SLAB_LIMESTONE_POLISHED, Blocks.SLAB_GRANITE_POLISHED, Blocks.SLAB_CAPSTONE_MARBLE };
+
+        for (int i = 0; i < statueItems.length; i++) {
+            RecipeBuilder.Shaped(CORE_NAMESPACE)
+                .setShape(
+                    "#",
+                    "#",
+                    "_"
+                )
+                .addInput('#', statueBodyBlocks[i])
+                .addInput('_', statueBaseBlocks[i])
+                .create("statue_" + statueNames[i], new ItemStack(statueItems[i], 1));
+        }
+    }
 }
